<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: MAMS (c) 2020-2021 by CMS Made Simple Foundation
#  An add-on module for CMS Made Simple to provide useful functions
#  and commonly used gui capabilities to other modules.
#-------------------------------------------------------------------------
# A fork of:
#
# Module: FrontEndUsers (c) 2008-2014 by Robert Campbell
#         (calguy1000@cmsmadesimple.org)
#
#-------------------------------------------------------------------------
#
# CMSMS - CMS Made Simple is (c) 2006 - 2021 by CMS Made Simple Foundation
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE

namespace MAMS\Commands;
use CMSMS\CLI\App;
use CMSMS\CLI\GetOptExt\Command;
use CMSMS\CLI\GetOptExt\Option;
use CMSMS\CLI\GetOptExt\GetOpt;
use GetOpt\Operand;
use mams_user_query;
use mams_user_query_opt;
use cms_utils;

class PropEditCommand extends Command
{
    public function __construct( App $app )
    {
        parent::__construct( $app, 'mams-prop-edit' );
        $this->addOperand( new Operand( 'prop', Operand::REQUIRED ) );
        $this->addOperand( new Operand( 'filename', Operand::OPTIONAL ) );
    }

    public function getShortDescription()
    {
        return 'Edit an FEU Property definition';
    }

    public function getLongDescription()
    {
        $out = <<<EOT
Edit an FEU Property definition given JSON input.  If a filename is not provided, then stdin is asumed.

Note. it is possible to break an existing site with this command.  Use caution.
EOT;
    }

    public function handle()
    {
        $prop = trim($this->getOperand('prop')->value());
        $filename = trim($this->getOperand('filename')->value());
        if( !$filename || $filename == '--' ) $filename = 'php://stdin';
        $text = trim(file_get_contents($filename));
        $mams = cms_utils::get_module(MOD_MAMS);

        $defn = $mams->GetPropertyDefn($prop);
        if( !$defn ) throw new \RuntimeException("Property $prop not found");

        $json = json_decode($text,TRUE);
        if( !is_array($json) || empty($json) ) throw new \RuntimeException('Cannot decode json input');

        $prop_rec = null;
        if( !isset($json[$prop]) || !is_array($json[$prop]) ) {
            if( isset($json['name']) || isset($json['type']) || isset($json['prompt']) ) {
                $prop_rec = $json;
            } else {
                throw new \RuntimeException('Invalid JSON data');
            }
        } else {
            $prop_rec = $json[$prop];
        }

        // now merge the defn info with the prop_rec
        $prop_rec = array_merge($defn,$prop_rec);
        $res = $mams->SetPropertyDefn( $prop, $prop_rec['name'], $prop_rec['prompt'], $prop_rec['length'], $prop_rec['type'],
                                      $prop_rec['maxlength'], $prop_rec['attribs'], $prop_rec['force_unique'], $prop_rec['encrypt'] );
        if( !$res ) throw new \RuntimeException('Property update failed');
    }
} // end of class.
